local uci = require "luci.model.uci".cursor()
local ds = require "luci.dispatcher"
local sys = require "luci.sys"

m = Map("tty2tcp", "", "")

section_global = m:section(NamedSection, "global", "tty2tcp", translate("Enable/ Disable"))
section_global.anonymous = true
section_global.addremove = false
section_global.name = "global"

option_enabled = section_global:option(Flag, "enabled", translate("Enabled"), translate("Enable DLMS Passthrough"))
option_enabled.rmempty=false
option_enabled.default="1"

--Proxy
s = m:section(TypedSection, "tty2tcp", "Passthrough Configuration")
s.addremove = false
s.anonymous = false

port_proxy = s:option(Value, "port", translate("TCP Port"))
port_proxy.default = "4059"
port_proxy.datatype = "port"

protocol_proxy = s:option(ListValue,"protocol", "Protocol")
protocol_proxy:value("raw", "raw")
protocol_proxy:value("telnet", "telnet")

timeout_proxy = s:option(Value, "timeout", translate("Timeout (seconds)"))
timeout_proxy.default = "30"
timeout_proxy.datatype = "range(0,3660)"

device_proxy = s:option(ListValue, "serial_port_number", translate("Serial Port"))
device_proxy:value("/dev/ttyHSL0", "RS485 Port")

baudrate_proxy = s:option(ListValue, "baudrate", translate("Serial Port Baud rate"))
baudrate_proxy:value("9600", "9600")
baudrate_proxy:value("19200", "19200")
baudrate_proxy:value("38400", "38400")
baudrate_proxy:value("57600", "57600")
baudrate_proxy:value("115200", "115200")
baudrate_proxy.default = "115200"

databits_proxy = s:option(ListValue, "data_bit", translate("Data bits"))
databits_proxy:value("8", "8")
databits_proxy.default = "8"

parity_proxy = s:option(ListValue, "parity", translate("Parity"))
parity_proxy:value("none", translate("None"))
parity_proxy:value("even", translate("Even"))
parity_proxy:value("odd", translate("Odd"))
parity_proxy.default = "none"

stopbits_proxy = s:option(ListValue, "stop_bit", translate("Stop bits"))
stopbits_proxy:value("1", "1")
stopbits_proxy.default = "1"


return m
